/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsIURIMutator.idl
 */

#ifndef __gen_nsIURIMutator_h__
#define __gen_nsIURIMutator_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIURI; /* forward declaration */

class nsIObjectInputStream; /* forward declaration */

class nsIURIMutator; /* forward declaration */

#include "nsStringGlue.h"
#include "nsCOMPtr.h"
#undef SetPort  // XXX Windows!
namespace mozilla {
class Encoding;
}
namespace mozilla {
namespace ipc {
class URIParams;
} // namespace ipc
} // namespace mozilla
template <class T>
class BaseURIMutator
{
// This is the base class that can be extended by implementors of nsIURIMutator
// in order to avoid code duplication
// Class type T should be the type of the class that implements nsIURI
protected:
    nsresult InitFromURI(T* aURI)
    {
        nsCOMPtr<nsIURI> clone;
        nsresult rv = aURI->Clone(getter_AddRefs(clone));
        if (NS_FAILED(rv)) {
            return rv;
        }
        mURI = static_cast<T*>(clone.get());
        return NS_OK;
    }
    nsresult InitFromInputStream(nsIObjectInputStream* aStream)
    {
        RefPtr<T> uri = new T();
        nsresult rv = uri->Read(aStream);
        if (NS_FAILED(rv)) {
            return rv;
        }
        mURI = uri;
        return NS_OK;
    }
    nsresult InitFromIPCParams(const mozilla::ipc::URIParams& aParams)
    {
        RefPtr<T> uri = new T();
        bool ret = uri->Deserialize(aParams);
        if (!ret) {
          return NS_ERROR_FAILURE;
        }
        mURI = uri;
        return NS_OK;
    }
    nsresult InitFromSpec(const nsACString& aSpec)
    {
        RefPtr<T> uri = new T();
        nsresult rv = uri->SetSpec(aSpec);
        if (NS_FAILED(rv)) {
          return rv;
        }
        mURI = uri;
        return NS_OK;
    }
    RefPtr<T> mURI;
};
// Since most implementations of nsIURIMutator would extend BaseURIMutator,
// some methods would have the same implementation. We provide a useful macro
// to avoid code duplication.
#define NS_DEFINE_NSIMUTATOR_COMMON                                           \
  NS_IMETHOD Deserialize(const mozilla::ipc::URIParams& aParams) override     \
    { return InitFromIPCParams(aParams); }                                    \
  NS_IMETHOD Read(nsIObjectInputStream* aStream) override                     \
    { return InitFromInputStream(aStream); }                                  \
  NS_IMETHOD Finalize(nsIURI** aURI) override                                 \
    { mURI.forget(aURI); return NS_OK; }                                      \
  NS_IMETHOD SetSpec(const nsACString & aSpec, nsIURIMutator** aMutator) override \
    { if (aMutator) NS_ADDREF(*aMutator = this); return InitFromSpec(aSpec); }

/* starting interface:    nsIURISetSpec */
#define NS_IURISETSPEC_IID_STR "1fc53257-898b-4c5e-b69c-05bc84b4cd8f"

#define NS_IURISETSPEC_IID \
  {0x1fc53257, 0x898b, 0x4c5e, \
    { 0xb6, 0x9c, 0x05, 0xbc, 0x84, 0xb4, 0xcd, 0x8f }}

class NS_NO_VTABLE nsIURISetSpec : public nsISupports {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IURISETSPEC_IID)

  /* nsIURIMutator setSpec (in AUTF8String aSpec); */
  NS_IMETHOD SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIURISetSpec, NS_IURISETSPEC_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIURISETSPEC \
  NS_IMETHOD SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIURISETSPEC \
  nsresult SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIURISETSPEC(_to) \
  NS_IMETHOD SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval) override { return _to SetSpec(aSpec, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIURISETSPEC(_to) \
  NS_IMETHOD SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetSpec(aSpec, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsURISetSpec : public nsIURISetSpec
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIURISETSPEC

  nsURISetSpec();

private:
  ~nsURISetSpec();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsURISetSpec, nsIURISetSpec)

nsURISetSpec::nsURISetSpec()
{
  /* member initializers and constructor code */
}

nsURISetSpec::~nsURISetSpec()
{
  /* destructor code */
}

/* nsIURIMutator setSpec (in AUTF8String aSpec); */
NS_IMETHODIMP nsURISetSpec::SetSpec(const nsACString & aSpec, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


/* starting interface:    nsIURISetters */
#define NS_IURISETTERS_IID_STR "5403a6ec-99d7-405e-8b45-9f805bbdfcef"

#define NS_IURISETTERS_IID \
  {0x5403a6ec, 0x99d7, 0x405e, \
    { 0x8b, 0x45, 0x9f, 0x80, 0x5b, 0xbd, 0xfc, 0xef }}

class NS_NO_VTABLE nsIURISetters : public nsIURISetSpec {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IURISETTERS_IID)

  /* nsIURIMutator setScheme (in AUTF8String aScheme); */
  NS_IMETHOD SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setUserPass (in AUTF8String aUserPass); */
  NS_IMETHOD SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setUsername (in AUTF8String aUsername); */
  NS_IMETHOD SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setPassword (in AUTF8String aPassword); */
  NS_IMETHOD SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setHostPort (in AUTF8String aHostPort); */
  NS_IMETHOD SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setHostAndPort (in AUTF8String aHostAndPort); */
  NS_IMETHOD SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setHost (in AUTF8String aHost); */
  NS_IMETHOD SetHost(const nsACString & aHost, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setPort (in long aPort); */
  NS_IMETHOD SetPort(int32_t aPort, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setPath (in AUTF8String aPathQueryRef); */
  NS_IMETHOD SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setRef (in AUTF8String aRef); */
  NS_IMETHOD SetRef(const nsACString & aRef, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setFilePath (in AUTF8String aFilePath); */
  NS_IMETHOD SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval) = 0;

  /* nsIURIMutator setQuery (in AUTF8String aQuery); */
  NS_IMETHOD SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval) = 0;

  /* [noscript] nsIURIMutator setQueryWithEncoding (in AUTF8String query, in Encoding encoding); */
  NS_IMETHOD SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIURISetters, NS_IURISETTERS_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIURISETTERS \
  NS_IMETHOD SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetHost(const nsACString & aHost, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetPort(int32_t aPort, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetRef(const nsACString & aRef, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval) override; \
  NS_IMETHOD SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIURISETTERS \
  nsresult SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval); \
  nsresult SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval); \
  nsresult SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval); \
  nsresult SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval); \
  nsresult SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval); \
  nsresult SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval); \
  nsresult SetHost(const nsACString & aHost, nsIURIMutator * *_retval); \
  nsresult SetPort(int32_t aPort, nsIURIMutator * *_retval); \
  nsresult SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval); \
  nsresult SetRef(const nsACString & aRef, nsIURIMutator * *_retval); \
  nsresult SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval); \
  nsresult SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval); \
  nsresult SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIURISETTERS(_to) \
  NS_IMETHOD SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval) override { return _to SetScheme(aScheme, _retval); } \
  NS_IMETHOD SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval) override { return _to SetUserPass(aUserPass, _retval); } \
  NS_IMETHOD SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval) override { return _to SetUsername(aUsername, _retval); } \
  NS_IMETHOD SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval) override { return _to SetPassword(aPassword, _retval); } \
  NS_IMETHOD SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval) override { return _to SetHostPort(aHostPort, _retval); } \
  NS_IMETHOD SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval) override { return _to SetHostAndPort(aHostAndPort, _retval); } \
  NS_IMETHOD SetHost(const nsACString & aHost, nsIURIMutator * *_retval) override { return _to SetHost(aHost, _retval); } \
  NS_IMETHOD SetPort(int32_t aPort, nsIURIMutator * *_retval) override { return _to SetPort(aPort, _retval); } \
  NS_IMETHOD SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval) override { return _to SetPath(aPathQueryRef, _retval); } \
  NS_IMETHOD SetRef(const nsACString & aRef, nsIURIMutator * *_retval) override { return _to SetRef(aRef, _retval); } \
  NS_IMETHOD SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval) override { return _to SetFilePath(aFilePath, _retval); } \
  NS_IMETHOD SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval) override { return _to SetQuery(aQuery, _retval); } \
  NS_IMETHOD SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval) override { return _to SetQueryWithEncoding(query, encoding, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIURISETTERS(_to) \
  NS_IMETHOD SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetScheme(aScheme, _retval); } \
  NS_IMETHOD SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUserPass(aUserPass, _retval); } \
  NS_IMETHOD SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetUsername(aUsername, _retval); } \
  NS_IMETHOD SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPassword(aPassword, _retval); } \
  NS_IMETHOD SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHostPort(aHostPort, _retval); } \
  NS_IMETHOD SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHostAndPort(aHostAndPort, _retval); } \
  NS_IMETHOD SetHost(const nsACString & aHost, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetHost(aHost, _retval); } \
  NS_IMETHOD SetPort(int32_t aPort, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPort(aPort, _retval); } \
  NS_IMETHOD SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetPath(aPathQueryRef, _retval); } \
  NS_IMETHOD SetRef(const nsACString & aRef, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetRef(aRef, _retval); } \
  NS_IMETHOD SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetFilePath(aFilePath, _retval); } \
  NS_IMETHOD SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetQuery(aQuery, _retval); } \
  NS_IMETHOD SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SetQueryWithEncoding(query, encoding, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsURISetters : public nsIURISetters
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIURISETTERS

  nsURISetters();

private:
  ~nsURISetters();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsURISetters, nsIURISetters)

nsURISetters::nsURISetters()
{
  /* member initializers and constructor code */
}

nsURISetters::~nsURISetters()
{
  /* destructor code */
}

/* nsIURIMutator setScheme (in AUTF8String aScheme); */
NS_IMETHODIMP nsURISetters::SetScheme(const nsACString & aScheme, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setUserPass (in AUTF8String aUserPass); */
NS_IMETHODIMP nsURISetters::SetUserPass(const nsACString & aUserPass, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setUsername (in AUTF8String aUsername); */
NS_IMETHODIMP nsURISetters::SetUsername(const nsACString & aUsername, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setPassword (in AUTF8String aPassword); */
NS_IMETHODIMP nsURISetters::SetPassword(const nsACString & aPassword, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setHostPort (in AUTF8String aHostPort); */
NS_IMETHODIMP nsURISetters::SetHostPort(const nsACString & aHostPort, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setHostAndPort (in AUTF8String aHostAndPort); */
NS_IMETHODIMP nsURISetters::SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setHost (in AUTF8String aHost); */
NS_IMETHODIMP nsURISetters::SetHost(const nsACString & aHost, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setPort (in long aPort); */
NS_IMETHODIMP nsURISetters::SetPort(int32_t aPort, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setPath (in AUTF8String aPathQueryRef); */
NS_IMETHODIMP nsURISetters::SetPath(const nsACString & aPathQueryRef, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setRef (in AUTF8String aRef); */
NS_IMETHODIMP nsURISetters::SetRef(const nsACString & aRef, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setFilePath (in AUTF8String aFilePath); */
NS_IMETHODIMP nsURISetters::SetFilePath(const nsACString & aFilePath, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURIMutator setQuery (in AUTF8String aQuery); */
NS_IMETHODIMP nsURISetters::SetQuery(const nsACString & aQuery, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript] nsIURIMutator setQueryWithEncoding (in AUTF8String query, in Encoding encoding); */
NS_IMETHODIMP nsURISetters::SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


// Using this macro instead of NS_FORWARD_SAFE_NSIURISETTERS makes chaining
// setter operations possible.
#define NS_FORWARD_SAFE_NSIURISETTERS_RET(_to)                                                                                         \
  NS_IMETHOD SetScheme(const nsACString & aScheme, nsIURIMutator** aMutator) override                                                  \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetScheme(aScheme); }                      \
  NS_IMETHOD SetUserPass(const nsACString & aUserPass, nsIURIMutator** aMutator) override                                              \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetUserPass(aUserPass); }                  \
  NS_IMETHOD SetUsername(const nsACString & aUsername, nsIURIMutator** aMutator) override                                              \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetUsername(aUsername); }                  \
  NS_IMETHOD SetPassword(const nsACString & aPassword, nsIURIMutator** aMutator) override                                              \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetPassword(aPassword); }                  \
  NS_IMETHOD SetHostPort(const nsACString & aHostPort, nsIURIMutator** aMutator) override                                              \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetHostPort(aHostPort); }                  \
  NS_IMETHOD SetHostAndPort(const nsACString & aHostAndPort, nsIURIMutator** aMutator) override                                        \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetHostAndPort(aHostAndPort); }            \
  NS_IMETHOD SetHost(const nsACString & aHost, nsIURIMutator** aMutator) override                                                      \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetHost(aHost); }                          \
  NS_IMETHOD SetPort(int32_t aPort, nsIURIMutator** aMutator) override                                                                 \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetPort(aPort); }                          \
  NS_IMETHOD SetPath(const nsACString & aPathQueryRef, nsIURIMutator** aMutator) override                                      \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetPath(aPathQueryRef); }          \
  NS_IMETHOD SetRef(const nsACString & aRef, nsIURIMutator** aMutator) override                                                        \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetRef(aRef); }                            \
  NS_IMETHOD SetFilePath(const nsACString & aFilePath, nsIURIMutator** aMutator) override                                              \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetFilePath(aFilePath); }                  \
  NS_IMETHOD SetQuery(const nsACString & aQuery, nsIURIMutator** aMutator) override                                                    \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetQuery(aQuery); }                        \
  NS_IMETHOD SetQueryWithEncoding(const nsACString & query, const mozilla::Encoding *encoding, nsIURIMutator** aMutator) override      \
    { if (aMutator) NS_ADDREF(*aMutator = this); return !_to ? NS_ERROR_NULL_POINTER : _to->SetQueryWithEncoding(query, encoding); }

/* starting interface:    nsIURIMutator */
#define NS_IURIMUTATOR_IID_STR "4d1f3103-1c44-4dcd-b717-5d22a697a7d9"

#define NS_IURIMUTATOR_IID \
  {0x4d1f3103, 0x1c44, 0x4dcd, \
    { 0xb7, 0x17, 0x5d, 0x22, 0xa6, 0x97, 0xa7, 0xd9 }}

class NS_NO_VTABLE nsIURIMutator : public nsIURISetters {
 public:

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_IURIMUTATOR_IID)

  /* void read (in nsIObjectInputStream aInputStream); */
  NS_IMETHOD Read(nsIObjectInputStream *aInputStream) = 0;

  /* [noscript,notxpcom] nsresult deserialize (in const_URIParams_ref aParams); */
  NS_IMETHOD_(nsresult) Deserialize(const mozilla::ipc::URIParams & aParams) = 0;

  /* nsIURI finalize (); */
  NS_IMETHOD Finalize(nsIURI * *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsIURIMutator, NS_IURIMUTATOR_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSIURIMUTATOR \
  NS_IMETHOD Read(nsIObjectInputStream *aInputStream) override; \
  NS_IMETHOD_(nsresult) Deserialize(const mozilla::ipc::URIParams & aParams) override; \
  NS_IMETHOD Finalize(nsIURI * *_retval) override; 

/* Use this macro when declaring the members of this interface when the
   class doesn't implement the interface. This is useful for forwarding. */
#define NS_DECL_NON_VIRTUAL_NSIURIMUTATOR \
  nsresult Read(nsIObjectInputStream *aInputStream); \
  nsresult_(nsresult) Deserialize(const mozilla::ipc::URIParams & aParams); \
  nsresult Finalize(nsIURI * *_retval); 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSIURIMUTATOR(_to) \
  NS_IMETHOD Read(nsIObjectInputStream *aInputStream) override { return _to Read(aInputStream); } \
  NS_IMETHOD_(nsresult) Deserialize(const mozilla::ipc::URIParams & aParams) override { return _to Deserialize(aParams); } \
  NS_IMETHOD Finalize(nsIURI * *_retval) override { return _to Finalize(_retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSIURIMUTATOR(_to) \
  NS_IMETHOD Read(nsIObjectInputStream *aInputStream) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Read(aInputStream); } \
  NS_IMETHOD_(nsresult) Deserialize(const mozilla::ipc::URIParams & aParams) override; \
  NS_IMETHOD Finalize(nsIURI * *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->Finalize(_retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsURIMutator : public nsIURIMutator
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSIURIMUTATOR

  nsURIMutator();

private:
  ~nsURIMutator();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsURIMutator, nsIURIMutator)

nsURIMutator::nsURIMutator()
{
  /* member initializers and constructor code */
}

nsURIMutator::~nsURIMutator()
{
  /* destructor code */
}

/* void read (in nsIObjectInputStream aInputStream); */
NS_IMETHODIMP nsURIMutator::Read(nsIObjectInputStream *aInputStream)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* [noscript,notxpcom] nsresult deserialize (in const_URIParams_ref aParams); */
NS_IMETHODIMP_(nsresult) nsURIMutator::Deserialize(const mozilla::ipc::URIParams & aParams)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* nsIURI finalize (); */
NS_IMETHODIMP nsURIMutator::Finalize(nsIURI * *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


// This class provides a useful helper that allows chaining of setter operations
class MOZ_STACK_CLASS NS_MutateURI
{
public:
  explicit NS_MutateURI(nsIURI* aURI);
  explicit NS_MutateURI(const char * aContractID);
  NS_MutateURI& SetSpec(const nsACString& aSpec)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetSpec(aSpec, nullptr);
    return *this;
  }
  NS_MutateURI& SetScheme(const nsACString& aScheme)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetScheme(aScheme, nullptr);
    return *this;
  }
  NS_MutateURI& SetUserPass(const nsACString& aUserPass)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetUserPass(aUserPass, nullptr);
    return *this;
  }
  NS_MutateURI& SetUsername(const nsACString& aUsername)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetUsername(aUsername, nullptr);
    return *this;
  }
  NS_MutateURI& SetPassword(const nsACString& aPassword)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetPassword(aPassword, nullptr);
    return *this;
  }
  NS_MutateURI& SetHostPort(const nsACString& aHostPort)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetHostPort(aHostPort, nullptr);
    return *this;
  }
  NS_MutateURI& SetHostAndPort(const nsACString& aHostAndPort)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetHostAndPort(aHostAndPort, nullptr);
    return *this;
  }
  NS_MutateURI& SetHost(const nsACString& aHost)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetHost(aHost, nullptr);
    return *this;
  }
  NS_MutateURI& SetPort(int32_t aPort)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetPort(aPort, nullptr);
    return *this;
  }
  NS_MutateURI& SetPath(const nsACString& aPathQueryRef)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetPath(aPathQueryRef, nullptr);
    return *this;
  }
  NS_MutateURI& SetRef(const nsACString& aRef)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetRef(aRef, nullptr);
    return *this;
  }
  NS_MutateURI& SetFilePath(const nsACString& aFilePath)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetFilePath(aFilePath, nullptr);
    return *this;
  }
  NS_MutateURI& SetQuery(const nsACString& aQuery)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetQuery(aQuery, nullptr);
    return *this;
  }
  NS_MutateURI& SetQueryWithEncoding(const nsACString& query, const mozilla::Encoding *encoding)
  {
    NS_ENSURE_SUCCESS(mStatus, *this);
    mStatus = mMutator->SetQueryWithEncoding(query, encoding, nullptr);
    return *this;
  }
  template <class C>
  nsresult Finalize(nsCOMPtr<C>& aURI)
  {
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    nsCOMPtr<nsIURI> uri;
    mStatus = mMutator->Finalize(getter_AddRefs(uri));
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    aURI = do_QueryInterface(uri, &mStatus);
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    return NS_OK;
  }
  // Overload for nsIURI to avoid query interface.
  nsresult Finalize(nsCOMPtr<nsIURI>& aURI)
  {
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    mStatus = mMutator->Finalize(getter_AddRefs(aURI));
    return mStatus;
  }
  template <class C>
  nsresult Finalize(C** aURI)
  {
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    nsCOMPtr<nsIURI> uri;
    mStatus = mMutator->Finalize(getter_AddRefs(uri));
    nsCOMPtr<C> result = do_QueryInterface(uri, &mStatus);
    result.forget(aURI);
    return mStatus;
  }
  nsresult Finalize(nsIURI** aURI)
  {
    NS_ENSURE_SUCCESS(mStatus, mStatus);
    mStatus = mMutator->Finalize(aURI);
    return mStatus;
  }
  nsresult GetStatus() { return mStatus; }
private:
  nsresult mStatus;
  nsCOMPtr<nsIURIMutator> mMutator;
};

#endif /* __gen_nsIURIMutator_h__ */
