//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layers/WebRenderMessageUtils.h"
#include "mozilla/layers/PTextureParent.h"
#include "mozilla/layers/PTextureChild.h"
#include "mozilla/layers/WebRenderMessages.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union OptionalTransform|
//
namespace mozilla {
namespace layers {
auto OptionalTransform::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TMatrix4x4:
        {
            (ptr_Matrix4x4())->~Matrix4x4__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(const Matrix4x4& aOther)
{
    new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4(aOther);
    mType = TMatrix4x4;
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(Matrix4x4&& aOther)
{
    new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4(mozilla::Move(aOther));
    mType = TMatrix4x4;
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(const void_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(void_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move(aOther));
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(const OptionalTransform& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TMatrix4x4:
        {
            new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4((aOther).get_Matrix4x4());
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT OptionalTransform::OptionalTransform(OptionalTransform&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TMatrix4x4:
        {
            new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4(mozilla::Move((aOther).get_Matrix4x4()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move((aOther).get_void_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

OptionalTransform::~OptionalTransform()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto OptionalTransform::operator=(const Matrix4x4& aRhs) -> OptionalTransform&
{
    if (MaybeDestroy(TMatrix4x4)) {
        new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4;
    }
    (*(ptr_Matrix4x4())) = aRhs;
    mType = TMatrix4x4;
    return (*(this));
}

auto OptionalTransform::operator=(Matrix4x4&& aRhs) -> OptionalTransform&
{
    if (MaybeDestroy(TMatrix4x4)) {
        new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4;
    }
    (*(ptr_Matrix4x4())) = mozilla::Move(aRhs);
    mType = TMatrix4x4;
    return (*(this));
}

auto OptionalTransform::operator=(const void_t& aRhs) -> OptionalTransform&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalTransform::operator=(void_t&& aRhs) -> OptionalTransform&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = mozilla::Move(aRhs);
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalTransform::operator=(const OptionalTransform& aRhs) -> OptionalTransform&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TMatrix4x4:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4;
            }
            (*(ptr_Matrix4x4())) = (aRhs).get_Matrix4x4();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto OptionalTransform::operator=(OptionalTransform&& aRhs) -> OptionalTransform&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TMatrix4x4:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_Matrix4x4()) Matrix4x4;
            }
            (*(ptr_Matrix4x4())) = mozilla::Move((aRhs).get_Matrix4x4());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = mozilla::Move((aRhs).get_void_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto OptionalTransform::operator==(const Matrix4x4& aRhs) const -> bool
{
    return (get_Matrix4x4()) == (aRhs);
}

auto OptionalTransform::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto OptionalTransform::operator==(const OptionalTransform& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TMatrix4x4:
        {
            return (get_Matrix4x4()) == ((aRhs).get_Matrix4x4());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto OptionalTransform::get(Matrix4x4* aOutValue) const -> void
{
    (*(aOutValue)) = get_Matrix4x4();
}

auto OptionalTransform::get(void_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_void_t();
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::OptionalTransform>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    typedef mozilla::layers::OptionalTransform union__;
    int type;
    type = (aVar).type();
    WriteIPDLParam(aMsg, aActor, type);
    // Sentinel = 'OptionalTransform'
    (aMsg)->WriteSentinel(703005225);

    switch (type) {
    case union__::TMatrix4x4:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_Matrix4x4());
            // Sentinel = 'TMatrix4x4'
            (aMsg)->WriteSentinel(1886581935);
            return;
        }
    case union__::Tvoid_t:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_void_t());
            // Sentinel = 'Tvoid_t'
            (aMsg)->WriteSentinel(3041273328);
            return;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return;
        }
    }
}

auto IPDLParamTraits<mozilla::layers::OptionalTransform>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    typedef mozilla::layers::OptionalTransform union__;
    int type;
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&(type)))))) {
        (aActor)->FatalError("Error deserializing type of union OptionalTransform");
        return false;
    }
    // Sentinel = 'OptionalTransform'
    if ((!((aMsg)->ReadSentinel(aIter, 703005225)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union OptionalTransform");
        return false;
    }

    switch (type) {
    case union__::TMatrix4x4:
        {
            mozilla::gfx::Matrix4x4 tmp = mozilla::gfx::Matrix4x4();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_Matrix4x4())))))) {
                (aActor)->FatalError("Error deserializing variant TMatrix4x4 of union OptionalTransform");
                return false;
            }
            // Sentinel = 'TMatrix4x4'
            if ((!((aMsg)->ReadSentinel(aIter, 1886581935)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TMatrix4x4 of union OptionalTransform");
                return false;
            }
            return true;
        }
    case union__::Tvoid_t:
        {
            mozilla::void_t tmp = mozilla::void_t();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_void_t())))))) {
                (aActor)->FatalError("Error deserializing variant Tvoid_t of union OptionalTransform");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((aMsg)->ReadSentinel(aIter, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tvoid_t of union OptionalTransform");
                return false;
            }
            return true;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union OptionalOpacity|
//
namespace mozilla {
namespace layers {
auto OptionalOpacity::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case Tfloat:
        {
            (ptr_float())->~float__tdef();
            break;
        }
    case Tvoid_t:
        {
            (ptr_void_t())->~void_t__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(const float& aOther)
{
    new (mozilla::KnownNotNull, ptr_float()) float(aOther);
    mType = Tfloat;
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(float&& aOther)
{
    new (mozilla::KnownNotNull, ptr_float()) float(mozilla::Move(aOther));
    mType = Tfloat;
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(const void_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(aOther);
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(void_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move(aOther));
    mType = Tvoid_t;
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(const OptionalOpacity& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case Tfloat:
        {
            new (mozilla::KnownNotNull, ptr_float()) float((aOther).get_float());
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t((aOther).get_void_t());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT OptionalOpacity::OptionalOpacity(OptionalOpacity&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case Tfloat:
        {
            new (mozilla::KnownNotNull, ptr_float()) float(mozilla::Move((aOther).get_float()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tvoid_t:
        {
            new (mozilla::KnownNotNull, ptr_void_t()) void_t(mozilla::Move((aOther).get_void_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

OptionalOpacity::~OptionalOpacity()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto OptionalOpacity::operator=(const float& aRhs) -> OptionalOpacity&
{
    if (MaybeDestroy(Tfloat)) {
        new (mozilla::KnownNotNull, ptr_float()) float;
    }
    (*(ptr_float())) = aRhs;
    mType = Tfloat;
    return (*(this));
}

auto OptionalOpacity::operator=(float&& aRhs) -> OptionalOpacity&
{
    if (MaybeDestroy(Tfloat)) {
        new (mozilla::KnownNotNull, ptr_float()) float;
    }
    (*(ptr_float())) = mozilla::Move(aRhs);
    mType = Tfloat;
    return (*(this));
}

auto OptionalOpacity::operator=(const void_t& aRhs) -> OptionalOpacity&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = aRhs;
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalOpacity::operator=(void_t&& aRhs) -> OptionalOpacity&
{
    if (MaybeDestroy(Tvoid_t)) {
        new (mozilla::KnownNotNull, ptr_void_t()) void_t;
    }
    (*(ptr_void_t())) = mozilla::Move(aRhs);
    mType = Tvoid_t;
    return (*(this));
}

auto OptionalOpacity::operator=(const OptionalOpacity& aRhs) -> OptionalOpacity&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tfloat:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_float()) float;
            }
            (*(ptr_float())) = (aRhs).get_float();
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = (aRhs).get_void_t();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto OptionalOpacity::operator=(OptionalOpacity&& aRhs) -> OptionalOpacity&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case Tfloat:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_float()) float;
            }
            (*(ptr_float())) = mozilla::Move((aRhs).get_float());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tvoid_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_void_t()) void_t;
            }
            (*(ptr_void_t())) = mozilla::Move((aRhs).get_void_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto OptionalOpacity::operator==(const float& aRhs) const -> bool
{
    return (get_float()) == (aRhs);
}

auto OptionalOpacity::operator==(const void_t& aRhs) const -> bool
{
    return (get_void_t()) == (aRhs);
}

auto OptionalOpacity::operator==(const OptionalOpacity& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case Tfloat:
        {
            return (get_float()) == ((aRhs).get_float());
        }
    case Tvoid_t:
        {
            return (get_void_t()) == ((aRhs).get_void_t());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto OptionalOpacity::get(float* aOutValue) const -> void
{
    (*(aOutValue)) = get_float();
}

auto OptionalOpacity::get(void_t* aOutValue) const -> void
{
    (*(aOutValue)) = get_void_t();
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::OptionalOpacity>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    typedef mozilla::layers::OptionalOpacity union__;
    int type;
    type = (aVar).type();
    WriteIPDLParam(aMsg, aActor, type);
    // Sentinel = 'OptionalOpacity'
    (aMsg)->WriteSentinel(2560878060);

    switch (type) {
    case union__::Tfloat:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_float());
            // Sentinel = 'Tfloat'
            (aMsg)->WriteSentinel(2693237468);
            return;
        }
    case union__::Tvoid_t:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_void_t());
            // Sentinel = 'Tvoid_t'
            (aMsg)->WriteSentinel(3041273328);
            return;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return;
        }
    }
}

auto IPDLParamTraits<mozilla::layers::OptionalOpacity>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    typedef mozilla::layers::OptionalOpacity union__;
    int type;
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&(type)))))) {
        (aActor)->FatalError("Error deserializing type of union OptionalOpacity");
        return false;
    }
    // Sentinel = 'OptionalOpacity'
    if ((!((aMsg)->ReadSentinel(aIter, 2560878060)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union OptionalOpacity");
        return false;
    }

    switch (type) {
    case union__::Tfloat:
        {
            float tmp = float();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_float())))))) {
                (aActor)->FatalError("Error deserializing variant Tfloat of union OptionalOpacity");
                return false;
            }
            // Sentinel = 'Tfloat'
            if ((!((aMsg)->ReadSentinel(aIter, 2693237468)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tfloat of union OptionalOpacity");
                return false;
            }
            return true;
        }
    case union__::Tvoid_t:
        {
            mozilla::void_t tmp = mozilla::void_t();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_void_t())))))) {
                (aActor)->FatalError("Error deserializing variant Tvoid_t of union OptionalOpacity");
                return false;
            }
            // Sentinel = 'Tvoid_t'
            if ((!((aMsg)->ReadSentinel(aIter, 3041273328)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tvoid_t of union OptionalOpacity");
                return false;
            }
            return true;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct OpAddExternalImage|
//
namespace mozilla {
namespace layers {
auto OpAddExternalImage::operator==(const OpAddExternalImage& _o) const -> bool
{
    if ((!((externalImageId()) == ((_o).externalImageId())))) {
        return false;
    }
    if ((!((key()) == ((_o).key())))) {
        return false;
    }
    return true;
}

auto OpAddExternalImage::operator!=(const OpAddExternalImage& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::OpAddExternalImage>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    WriteIPDLParam(aMsg, aActor, (aVar).externalImageId());
    // Sentinel = 'externalImageId'
    (aMsg)->WriteSentinel(2839682692);
    WriteIPDLParam(aMsg, aActor, (aVar).key());
    // Sentinel = 'key'
    (aMsg)->WriteSentinel(35142870);
}

auto IPDLParamTraits<mozilla::layers::OpAddExternalImage>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->externalImageId())))))) {
        (aActor)->FatalError("Error deserializing 'externalImageId' (ExternalImageId) member of 'OpAddExternalImage'");
        return false;
    }
    // Sentinel = 'externalImageId'
    if ((!((aMsg)->ReadSentinel(aIter, 2839682692)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'externalImageId' (ExternalImageId) member of 'OpAddExternalImage'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->key())))))) {
        (aActor)->FatalError("Error deserializing 'key' (ImageKey) member of 'OpAddExternalImage'");
        return false;
    }
    // Sentinel = 'key'
    if ((!((aMsg)->ReadSentinel(aIter, 35142870)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'key' (ImageKey) member of 'OpAddExternalImage'");
        return false;
    }
    return true;
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct OpAddCompositorAnimations|
//
namespace mozilla {
namespace layers {
auto OpAddCompositorAnimations::operator==(const OpAddCompositorAnimations& _o) const -> bool
{
    if ((!((data()) == ((_o).data())))) {
        return false;
    }
    if ((!((transform()) == ((_o).transform())))) {
        return false;
    }
    if ((!((opacity()) == ((_o).opacity())))) {
        return false;
    }
    return true;
}

auto OpAddCompositorAnimations::operator!=(const OpAddCompositorAnimations& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::OpAddCompositorAnimations>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    WriteIPDLParam(aMsg, aActor, (aVar).data());
    // Sentinel = 'data'
    (aMsg)->WriteSentinel(843352540);
    WriteIPDLParam(aMsg, aActor, (aVar).transform());
    // Sentinel = 'transform'
    (aMsg)->WriteSentinel(69691181);
    WriteIPDLParam(aMsg, aActor, (aVar).opacity());
    // Sentinel = 'opacity'
    (aMsg)->WriteSentinel(3006582720);
}

auto IPDLParamTraits<mozilla::layers::OpAddCompositorAnimations>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->data())))))) {
        (aActor)->FatalError("Error deserializing 'data' (CompositorAnimations) member of 'OpAddCompositorAnimations'");
        return false;
    }
    // Sentinel = 'data'
    if ((!((aMsg)->ReadSentinel(aIter, 843352540)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'data' (CompositorAnimations) member of 'OpAddCompositorAnimations'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->transform())))))) {
        (aActor)->FatalError("Error deserializing 'transform' (OptionalTransform) member of 'OpAddCompositorAnimations'");
        return false;
    }
    // Sentinel = 'transform'
    if ((!((aMsg)->ReadSentinel(aIter, 69691181)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'transform' (OptionalTransform) member of 'OpAddCompositorAnimations'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->opacity())))))) {
        (aActor)->FatalError("Error deserializing 'opacity' (OptionalOpacity) member of 'OpAddCompositorAnimations'");
        return false;
    }
    // Sentinel = 'opacity'
    if ((!((aMsg)->ReadSentinel(aIter, 3006582720)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'opacity' (OptionalOpacity) member of 'OpAddCompositorAnimations'");
        return false;
    }
    return true;
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct OpUpdateAsyncImagePipeline|
//
namespace mozilla {
namespace layers {
auto OpUpdateAsyncImagePipeline::operator==(const OpUpdateAsyncImagePipeline& _o) const -> bool
{
    if ((!((pipelineId()) == ((_o).pipelineId())))) {
        return false;
    }
    if ((!((scBounds()) == ((_o).scBounds())))) {
        return false;
    }
    if ((!((scTransform()) == ((_o).scTransform())))) {
        return false;
    }
    if ((!((scaleToSize()) == ((_o).scaleToSize())))) {
        return false;
    }
    if ((!((filter()) == ((_o).filter())))) {
        return false;
    }
    if ((!((mixBlendMode()) == ((_o).mixBlendMode())))) {
        return false;
    }
    return true;
}

auto OpUpdateAsyncImagePipeline::operator!=(const OpUpdateAsyncImagePipeline& _o) const -> bool
{
    return (!(operator==(_o)));
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::OpUpdateAsyncImagePipeline>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    WriteIPDLParam(aMsg, aActor, (aVar).pipelineId());
    // Sentinel = 'pipelineId'
    (aMsg)->WriteSentinel(4067092043);
    WriteIPDLParam(aMsg, aActor, (aVar).scBounds());
    // Sentinel = 'scBounds'
    (aMsg)->WriteSentinel(448805933);
    WriteIPDLParam(aMsg, aActor, (aVar).scTransform());
    // Sentinel = 'scTransform'
    (aMsg)->WriteSentinel(1345782441);
    WriteIPDLParam(aMsg, aActor, (aVar).scaleToSize());
    // Sentinel = 'scaleToSize'
    (aMsg)->WriteSentinel(1078440273);
    WriteIPDLParam(aMsg, aActor, (aVar).filter());
    // Sentinel = 'filter'
    (aMsg)->WriteSentinel(2236769008);
    WriteIPDLParam(aMsg, aActor, (aVar).mixBlendMode());
    // Sentinel = 'mixBlendMode'
    (aMsg)->WriteSentinel(1158101226);
}

auto IPDLParamTraits<mozilla::layers::OpUpdateAsyncImagePipeline>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->pipelineId())))))) {
        (aActor)->FatalError("Error deserializing 'pipelineId' (PipelineId) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'pipelineId'
    if ((!((aMsg)->ReadSentinel(aIter, 4067092043)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'pipelineId' (PipelineId) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->scBounds())))))) {
        (aActor)->FatalError("Error deserializing 'scBounds' (LayerRect) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'scBounds'
    if ((!((aMsg)->ReadSentinel(aIter, 448805933)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'scBounds' (LayerRect) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->scTransform())))))) {
        (aActor)->FatalError("Error deserializing 'scTransform' (Matrix4x4) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'scTransform'
    if ((!((aMsg)->ReadSentinel(aIter, 1345782441)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'scTransform' (Matrix4x4) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->scaleToSize())))))) {
        (aActor)->FatalError("Error deserializing 'scaleToSize' (MaybeIntSize) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'scaleToSize'
    if ((!((aMsg)->ReadSentinel(aIter, 1078440273)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'scaleToSize' (MaybeIntSize) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->filter())))))) {
        (aActor)->FatalError("Error deserializing 'filter' (ImageRendering) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'filter'
    if ((!((aMsg)->ReadSentinel(aIter, 2236769008)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'filter' (ImageRendering) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->mixBlendMode())))))) {
        (aActor)->FatalError("Error deserializing 'mixBlendMode' (MixBlendMode) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    // Sentinel = 'mixBlendMode'
    if ((!((aMsg)->ReadSentinel(aIter, 1158101226)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'mixBlendMode' (MixBlendMode) member of 'OpUpdateAsyncImagePipeline'");
        return false;
    }
    return true;
}

} // namespace ipc
} // namespace mozilla

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union WebRenderParentCommand|
//
namespace mozilla {
namespace layers {
auto WebRenderParentCommand::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TOpAddExternalImage:
        {
            (ptr_OpAddExternalImage())->~OpAddExternalImage__tdef();
            break;
        }
    case TOpUpdateAsyncImagePipeline:
        {
            (ptr_OpUpdateAsyncImagePipeline())->~OpUpdateAsyncImagePipeline__tdef();
            break;
        }
    case TCompositableOperation:
        {
            (ptr_CompositableOperation())->~CompositableOperation__tdef();
            break;
        }
    case TOpAddCompositorAnimations:
        {
            (ptr_OpAddCompositorAnimations())->~OpAddCompositorAnimations__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(const OpAddExternalImage& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage(aOther);
    mType = TOpAddExternalImage;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(OpAddExternalImage&& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage(mozilla::Move(aOther));
    mType = TOpAddExternalImage;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(const OpUpdateAsyncImagePipeline& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline(aOther);
    mType = TOpUpdateAsyncImagePipeline;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(OpUpdateAsyncImagePipeline&& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline(mozilla::Move(aOther));
    mType = TOpUpdateAsyncImagePipeline;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(const CompositableOperation& aOther)
{
    new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation(aOther);
    mType = TCompositableOperation;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(CompositableOperation&& aOther)
{
    new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation(mozilla::Move(aOther));
    mType = TCompositableOperation;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(const OpAddCompositorAnimations& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations(aOther);
    mType = TOpAddCompositorAnimations;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(OpAddCompositorAnimations&& aOther)
{
    new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations(mozilla::Move(aOther));
    mType = TOpAddCompositorAnimations;
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(const WebRenderParentCommand& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TOpAddExternalImage:
        {
            new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage((aOther).get_OpAddExternalImage());
            break;
        }
    case TOpUpdateAsyncImagePipeline:
        {
            new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline((aOther).get_OpUpdateAsyncImagePipeline());
            break;
        }
    case TCompositableOperation:
        {
            new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation((aOther).get_CompositableOperation());
            break;
        }
    case TOpAddCompositorAnimations:
        {
            new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations((aOther).get_OpAddCompositorAnimations());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT WebRenderParentCommand::WebRenderParentCommand(WebRenderParentCommand&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TOpAddExternalImage:
        {
            new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage(mozilla::Move((aOther).get_OpAddExternalImage()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TOpUpdateAsyncImagePipeline:
        {
            new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline(mozilla::Move((aOther).get_OpUpdateAsyncImagePipeline()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TCompositableOperation:
        {
            new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation(mozilla::Move((aOther).get_CompositableOperation()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TOpAddCompositorAnimations:
        {
            new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations(mozilla::Move((aOther).get_OpAddCompositorAnimations()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

WebRenderParentCommand::~WebRenderParentCommand()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto WebRenderParentCommand::operator=(const OpAddExternalImage& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpAddExternalImage)) {
        new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage;
    }
    (*(ptr_OpAddExternalImage())) = aRhs;
    mType = TOpAddExternalImage;
    return (*(this));
}

auto WebRenderParentCommand::operator=(OpAddExternalImage&& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpAddExternalImage)) {
        new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage;
    }
    (*(ptr_OpAddExternalImage())) = mozilla::Move(aRhs);
    mType = TOpAddExternalImage;
    return (*(this));
}

auto WebRenderParentCommand::operator=(const OpUpdateAsyncImagePipeline& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpUpdateAsyncImagePipeline)) {
        new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline;
    }
    (*(ptr_OpUpdateAsyncImagePipeline())) = aRhs;
    mType = TOpUpdateAsyncImagePipeline;
    return (*(this));
}

auto WebRenderParentCommand::operator=(OpUpdateAsyncImagePipeline&& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpUpdateAsyncImagePipeline)) {
        new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline;
    }
    (*(ptr_OpUpdateAsyncImagePipeline())) = mozilla::Move(aRhs);
    mType = TOpUpdateAsyncImagePipeline;
    return (*(this));
}

auto WebRenderParentCommand::operator=(const CompositableOperation& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TCompositableOperation)) {
        new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation;
    }
    (*(ptr_CompositableOperation())) = aRhs;
    mType = TCompositableOperation;
    return (*(this));
}

auto WebRenderParentCommand::operator=(CompositableOperation&& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TCompositableOperation)) {
        new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation;
    }
    (*(ptr_CompositableOperation())) = mozilla::Move(aRhs);
    mType = TCompositableOperation;
    return (*(this));
}

auto WebRenderParentCommand::operator=(const OpAddCompositorAnimations& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpAddCompositorAnimations)) {
        new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations;
    }
    (*(ptr_OpAddCompositorAnimations())) = aRhs;
    mType = TOpAddCompositorAnimations;
    return (*(this));
}

auto WebRenderParentCommand::operator=(OpAddCompositorAnimations&& aRhs) -> WebRenderParentCommand&
{
    if (MaybeDestroy(TOpAddCompositorAnimations)) {
        new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations;
    }
    (*(ptr_OpAddCompositorAnimations())) = mozilla::Move(aRhs);
    mType = TOpAddCompositorAnimations;
    return (*(this));
}

auto WebRenderParentCommand::operator=(const WebRenderParentCommand& aRhs) -> WebRenderParentCommand&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TOpAddExternalImage:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage;
            }
            (*(ptr_OpAddExternalImage())) = (aRhs).get_OpAddExternalImage();
            break;
        }
    case TOpUpdateAsyncImagePipeline:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline;
            }
            (*(ptr_OpUpdateAsyncImagePipeline())) = (aRhs).get_OpUpdateAsyncImagePipeline();
            break;
        }
    case TCompositableOperation:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation;
            }
            (*(ptr_CompositableOperation())) = (aRhs).get_CompositableOperation();
            break;
        }
    case TOpAddCompositorAnimations:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations;
            }
            (*(ptr_OpAddCompositorAnimations())) = (aRhs).get_OpAddCompositorAnimations();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto WebRenderParentCommand::operator=(WebRenderParentCommand&& aRhs) -> WebRenderParentCommand&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TOpAddExternalImage:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpAddExternalImage()) OpAddExternalImage;
            }
            (*(ptr_OpAddExternalImage())) = mozilla::Move((aRhs).get_OpAddExternalImage());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TOpUpdateAsyncImagePipeline:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpUpdateAsyncImagePipeline()) OpUpdateAsyncImagePipeline;
            }
            (*(ptr_OpUpdateAsyncImagePipeline())) = mozilla::Move((aRhs).get_OpUpdateAsyncImagePipeline());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TCompositableOperation:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_CompositableOperation()) CompositableOperation;
            }
            (*(ptr_CompositableOperation())) = mozilla::Move((aRhs).get_CompositableOperation());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TOpAddCompositorAnimations:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_OpAddCompositorAnimations()) OpAddCompositorAnimations;
            }
            (*(ptr_OpAddCompositorAnimations())) = mozilla::Move((aRhs).get_OpAddCompositorAnimations());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

auto WebRenderParentCommand::operator==(const OpAddExternalImage& aRhs) const -> bool
{
    return (get_OpAddExternalImage()) == (aRhs);
}

auto WebRenderParentCommand::operator==(const OpUpdateAsyncImagePipeline& aRhs) const -> bool
{
    return (get_OpUpdateAsyncImagePipeline()) == (aRhs);
}

auto WebRenderParentCommand::operator==(const CompositableOperation& aRhs) const -> bool
{
    return (get_CompositableOperation()) == (aRhs);
}

auto WebRenderParentCommand::operator==(const OpAddCompositorAnimations& aRhs) const -> bool
{
    return (get_OpAddCompositorAnimations()) == (aRhs);
}

auto WebRenderParentCommand::operator==(const WebRenderParentCommand& aRhs) const -> bool
{
    if ((type()) != ((aRhs).type())) {
        return false;
    }

    switch (type()) {
    case TOpAddExternalImage:
        {
            return (get_OpAddExternalImage()) == ((aRhs).get_OpAddExternalImage());
        }
    case TOpUpdateAsyncImagePipeline:
        {
            return (get_OpUpdateAsyncImagePipeline()) == ((aRhs).get_OpUpdateAsyncImagePipeline());
        }
    case TCompositableOperation:
        {
            return (get_CompositableOperation()) == ((aRhs).get_CompositableOperation());
        }
    case TOpAddCompositorAnimations:
        {
            return (get_OpAddCompositorAnimations()) == ((aRhs).get_OpAddCompositorAnimations());
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return false;
        }
    }
}

auto WebRenderParentCommand::get(OpAddExternalImage* aOutValue) const -> void
{
    (*(aOutValue)) = get_OpAddExternalImage();
}

auto WebRenderParentCommand::get(OpUpdateAsyncImagePipeline* aOutValue) const -> void
{
    (*(aOutValue)) = get_OpUpdateAsyncImagePipeline();
}

auto WebRenderParentCommand::get(CompositableOperation* aOutValue) const -> void
{
    (*(aOutValue)) = get_CompositableOperation();
}

auto WebRenderParentCommand::get(OpAddCompositorAnimations* aOutValue) const -> void
{
    (*(aOutValue)) = get_OpAddCompositorAnimations();
}

} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace ipc {
auto IPDLParamTraits<mozilla::layers::WebRenderParentCommand>::Write(
        IPC::Message* aMsg,
        mozilla::ipc::IProtocol* aActor,
        const paramType& aVar) -> void
{
    typedef mozilla::layers::WebRenderParentCommand union__;
    int type;
    type = (aVar).type();
    WriteIPDLParam(aMsg, aActor, type);
    // Sentinel = 'WebRenderParentCommand'
    (aMsg)->WriteSentinel(2119870727);

    switch (type) {
    case union__::TOpAddExternalImage:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_OpAddExternalImage());
            // Sentinel = 'TOpAddExternalImage'
            (aMsg)->WriteSentinel(3145571349);
            return;
        }
    case union__::TOpUpdateAsyncImagePipeline:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_OpUpdateAsyncImagePipeline());
            // Sentinel = 'TOpUpdateAsyncImagePipeline'
            (aMsg)->WriteSentinel(2512870980);
            return;
        }
    case union__::TCompositableOperation:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_CompositableOperation());
            // Sentinel = 'TCompositableOperation'
            (aMsg)->WriteSentinel(1903999853);
            return;
        }
    case union__::TOpAddCompositorAnimations:
        {
            WriteIPDLParam(aMsg, aActor, (aVar).get_OpAddCompositorAnimations());
            // Sentinel = 'TOpAddCompositorAnimations'
            (aMsg)->WriteSentinel(3387367374);
            return;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return;
        }
    }
}

auto IPDLParamTraits<mozilla::layers::WebRenderParentCommand>::Read(
        const IPC::Message* aMsg,
        PickleIterator* aIter,
        mozilla::ipc::IProtocol* aActor,
        paramType* aVar) -> bool
{
    typedef mozilla::layers::WebRenderParentCommand union__;
    int type;
    if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&(type)))))) {
        (aActor)->FatalError("Error deserializing type of union WebRenderParentCommand");
        return false;
    }
    // Sentinel = 'WebRenderParentCommand'
    if ((!((aMsg)->ReadSentinel(aIter, 2119870727)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union WebRenderParentCommand");
        return false;
    }

    switch (type) {
    case union__::TOpAddExternalImage:
        {
            mozilla::layers::OpAddExternalImage tmp = mozilla::layers::OpAddExternalImage();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_OpAddExternalImage())))))) {
                (aActor)->FatalError("Error deserializing variant TOpAddExternalImage of union WebRenderParentCommand");
                return false;
            }
            // Sentinel = 'TOpAddExternalImage'
            if ((!((aMsg)->ReadSentinel(aIter, 3145571349)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TOpAddExternalImage of union WebRenderParentCommand");
                return false;
            }
            return true;
        }
    case union__::TOpUpdateAsyncImagePipeline:
        {
            mozilla::layers::OpUpdateAsyncImagePipeline tmp = mozilla::layers::OpUpdateAsyncImagePipeline();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_OpUpdateAsyncImagePipeline())))))) {
                (aActor)->FatalError("Error deserializing variant TOpUpdateAsyncImagePipeline of union WebRenderParentCommand");
                return false;
            }
            // Sentinel = 'TOpUpdateAsyncImagePipeline'
            if ((!((aMsg)->ReadSentinel(aIter, 2512870980)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TOpUpdateAsyncImagePipeline of union WebRenderParentCommand");
                return false;
            }
            return true;
        }
    case union__::TCompositableOperation:
        {
            mozilla::layers::CompositableOperation tmp = mozilla::layers::CompositableOperation();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_CompositableOperation())))))) {
                (aActor)->FatalError("Error deserializing variant TCompositableOperation of union WebRenderParentCommand");
                return false;
            }
            // Sentinel = 'TCompositableOperation'
            if ((!((aMsg)->ReadSentinel(aIter, 1903999853)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TCompositableOperation of union WebRenderParentCommand");
                return false;
            }
            return true;
        }
    case union__::TOpAddCompositorAnimations:
        {
            mozilla::layers::OpAddCompositorAnimations tmp = mozilla::layers::OpAddCompositorAnimations();
            (*(aVar)) = tmp;
            if ((!(ReadIPDLParam(aMsg, aIter, aActor, (&((aVar)->get_OpAddCompositorAnimations())))))) {
                (aActor)->FatalError("Error deserializing variant TOpAddCompositorAnimations of union WebRenderParentCommand");
                return false;
            }
            // Sentinel = 'TOpAddCompositorAnimations'
            if ((!((aMsg)->ReadSentinel(aIter, 3387367374)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TOpAddCompositorAnimations of union WebRenderParentCommand");
                return false;
            }
            return true;
        }
    default:
        {
            (aActor)->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace ipc
} // namespace mozilla
