//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebAuthnTransactionParent_h
#define PWebAuthnTransactionParent_h

#include "mozilla/dom/PWebAuthnTransaction.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PWebAuthnTransactionParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::dom::WebAuthnExtension WebAuthnExtension;
    typedef mozilla::dom::WebAuthnScopedCredentialDescriptor WebAuthnScopedCredentialDescriptor;
    typedef mozilla::dom::WebAuthnTransactionInfo WebAuthnTransactionInfo;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;

    typedef PWebAuthnTransaction::State State;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
    virtual mozilla::ipc::IPCResult
    RecvRequestRegister(const WebAuthnTransactionInfo& aTransactionInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestSign(const WebAuthnTransactionInfo& aTransactionInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvRequestCancel() = 0;

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebAuthnTransactionParent();

    virtual ~PWebAuthnTransactionParent();

    PBackgroundParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendConfirmRegister(const nsTArray<uint8_t>& RegBuffer);

    MOZ_MUST_USE bool
    SendConfirmSign(
            const nsTArray<uint8_t>& CredentialID,
            const nsTArray<uint8_t>& ReplyBuffer);

    MOZ_MUST_USE bool
    SendCancel(const nsresult& Error);

    void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::dom::PWebAuthnTransactionParent*>
{
    typedef mozilla::dom::PWebAuthnTransactionParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace dom {
class WebAuthnTransactionParent :
    public PWebAuthnTransactionParent
{
    mozilla::ipc::IPCResult
    RecvRequestRegister(const WebAuthnTransactionInfo& aTransactionInfo) override;

    mozilla::ipc::IPCResult
    RecvRequestSign(const WebAuthnTransactionInfo& aTransactionInfo) override;

    mozilla::ipc::IPCResult
    RecvRequestCancel() override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT WebAuthnTransactionParent();
    virtual ~WebAuthnTransactionParent();
};
} // namespace dom
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace dom {
mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestRegister(const WebAuthnTransactionInfo& aTransactionInfo)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestSign(const WebAuthnTransactionInfo& aTransactionInfo)
{
}

mozilla::ipc::IPCResult
WebAuthnTransactionParent::RecvRequestCancel()
{
}

void
WebAuthnTransactionParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT WebAuthnTransactionParent::WebAuthnTransactionParent()
{
    MOZ_COUNT_CTOR(WebAuthnTransactionParent);
}

MOZ_IMPLICIT WebAuthnTransactionParent::~WebAuthnTransactionParent()
{
    MOZ_COUNT_DTOR(WebAuthnTransactionParent);
}

} // namespace dom
} // namespace mozilla
#endif // if 0

#endif // ifndef PWebAuthnTransactionParent_h
