//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PHalParent_h
#define PHalParent_h

#include "mozilla/hal_sandbox/PHal.h"
#ifdef DEBUG
#include "prenv.h"
#endif // DEBUG
#include "base/id_map.h"
#include "mozilla/ipc/MessageChannel.h"

// Headers for things that cannot be forward declared
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/HalSensor.h"
#include "mozilla/HalTypes.h"
#include "mozilla/dom/ScreenOrientation.h"
#include "nsRect.h"
#include "prtime.h"

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PContentChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PBrowserParent;
} // namespace dom
} // namespace mozilla
namespace mozilla {
namespace dom {
class PBrowserChild;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace dom {
class PContentParent;
} // namespace dom
} // namespace mozilla

namespace mozilla {
namespace hal_sandbox {


class PHalParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::dom::PContentParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::hal::NetworkInformation NetworkInformation;
    typedef base::ProcessId ProcessId;
    typedef mozilla::hal::ProcessPriority ProcessPriority;
    typedef mozilla::ipc::PromiseRejectReason PromiseRejectReason;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::hal::ScreenConfiguration ScreenConfiguration;
    typedef mozilla::dom::ScreenOrientationInternal ScreenOrientationInternal;
    typedef mozilla::hal::SensorAccuracyType SensorAccuracyType;
    typedef mozilla::hal::SensorData SensorData;
    typedef mozilla::hal::SensorType SensorType;
    typedef mozilla::ipc::Shmem Shmem;
    typedef mozilla::hal::SwitchDevice SwitchDevice;
    typedef mozilla::hal::SwitchEvent SwitchEvent;
    typedef mozilla::hal::SwitchState SwitchState;
    typedef mozilla::hal::SystemTimezoneChangeInformation SystemTimezoneChangeInformation;
    typedef mozilla::ipc::Transport Transport;
    typedef mozilla::ipc::TransportDescriptor TransportDescriptor;
    typedef mozilla::hal::WakeLockControl WakeLockControl;
    typedef mozilla::hal::WakeLockInformation WakeLockInformation;
    typedef mozilla::dom::PContentParent PContentParent;
    typedef mozilla::dom::PContentChild PContentChild;
    typedef mozilla::dom::PBrowserParent PBrowserParent;
    typedef mozilla::dom::PBrowserChild PBrowserChild;

    typedef PHal::State State;

protected:
    virtual mozilla::ipc::IPCResult
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableNetworkNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableNetworkNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetScreenEnabled(bool* enabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetScreenEnabled(const bool& aEnabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetKeyLightEnabled(bool* enabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetKeyLightEnabled(const bool& aEnabled) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetCpuSleepAllowed(bool* allowed) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetCpuSleepAllowed(const bool& aAllowed) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetScreenBrightness(double* brightness) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetScreenBrightness(const double& aBrightness) = 0;
    virtual mozilla::ipc::IPCResult
    RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetTimezone(const nsCString& aTimezoneSpec) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetTimezone(nsCString* aTimezoneSpec) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetTimezoneOffset(int32_t* aTimezoneOffset) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableSystemClockChangeNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableSystemClockChangeNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableSystemTimezoneChangeNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableSystemTimezoneChangeNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableWakeLockNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableWakeLockNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableScreenConfigurationNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableScreenConfigurationNotifications() = 0;
    virtual mozilla::ipc::IPCResult
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUnlockScreenOrientation() = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableSwitchNotifications(const SwitchDevice& aDevice) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableSwitchNotifications(const SwitchDevice& aDevice) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetCurrentSwitchState(
            const SwitchDevice& aDevice,
            SwitchState* aState) = 0;
    virtual mozilla::ipc::IPCResult
    RecvFactoryReset(const nsString& aReason) = 0;
    virtual mozilla::ipc::IPCResult
    RecvEnableSensorNotifications(const SensorType& aSensor) = 0;
    virtual mozilla::ipc::IPCResult
    RecvDisableSensorNotifications(const SensorType& aSensor) = 0;
    virtual mozilla::ipc::IPCResult
    Recv__delete__();

    virtual void
    ActorDestroy(ActorDestroyReason aWhy) = 0;

public:
    typedef mozilla::ipc::IProtocol ProtocolBase;
    typedef IPC::Message Message;
    typedef mozilla::ipc::MessageChannel Channel;
    typedef mozilla::ipc::IProtocol ChannelListener;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PHalParent();

    virtual ~PHalParent();

    PContentParent*
    Manager() const;

    MOZ_MUST_USE bool
    SendNotifyNetworkChange(const NetworkInformation& aNetworkInfo);

    MOZ_MUST_USE bool
    SendNotifyWakeLockChange(const WakeLockInformation& aWakeLockInfo);

    MOZ_MUST_USE bool
    SendNotifyScreenConfigurationChange(const ScreenConfiguration& aScreenOrientation);

    MOZ_MUST_USE bool
    SendNotifySwitchChange(const SwitchEvent& aEvent);

    MOZ_MUST_USE bool
    SendNotifySystemClockChange(const int64_t& aClockDeltaMS);

    MOZ_MUST_USE bool
    SendNotifySystemTimezoneChange(const SystemTimezoneChangeInformation& aSystemTimezoneChangeInfo);

    MOZ_MUST_USE bool
    SendNotifySensorChange(const SensorData& aSensorData);

    void
    RemoveManagee(
            int32_t aProtocolId,
            ProtocolBase* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            Message*& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            Message*& reply__) override;

    int32_t
    GetProtocolTypeId() override;

private:
    const char*
    ProtocolName() const override;

    void
    DestroySubtree(ActorDestroyReason why);

    void
    DeallocSubtree();

    State mState;
};


} // namespace hal_sandbox
} // namespace mozilla
namespace mozilla {
namespace ipc {
template<>
struct IPDLParamTraits <mozilla::hal_sandbox::PHalParent*>
{
    typedef mozilla::hal_sandbox::PHalParent* paramType;
    static void
    Write(
            IPC::Message* aMsg,
            mozilla::ipc::IProtocol* aActor,
            const paramType& aVar);
    static bool
    Read(
            const IPC::Message* aMsg,
            PickleIterator* aIter,
            mozilla::ipc::IProtocol* aActor,
            paramType* aVar);
};
} // namespace ipc
} // namespace mozilla

#if 0

//-----------------------------------------------------------------------------
// Skeleton implementation of abstract actor class

// Header file contents
namespace mozilla {
namespace hal_sandbox {
class HalParent :
    public PHalParent
{
    mozilla::ipc::IPCResult
    RecvVibrate(
            nsTArray<uint32_t>&& pattern,
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) override;

    mozilla::ipc::IPCResult
    RecvCancelVibrate(
            nsTArray<uint64_t>&& id,
            PBrowserParent* browser) override;

    mozilla::ipc::IPCResult
    RecvEnableNetworkNotifications() override;

    mozilla::ipc::IPCResult
    RecvDisableNetworkNotifications() override;

    mozilla::ipc::IPCResult
    RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo) override;

    mozilla::ipc::IPCResult
    RecvGetScreenEnabled(bool* enabled) override;

    mozilla::ipc::IPCResult
    RecvSetScreenEnabled(const bool& aEnabled) override;

    mozilla::ipc::IPCResult
    RecvGetKeyLightEnabled(bool* enabled) override;

    mozilla::ipc::IPCResult
    RecvSetKeyLightEnabled(const bool& aEnabled) override;

    mozilla::ipc::IPCResult
    RecvGetCpuSleepAllowed(bool* allowed) override;

    mozilla::ipc::IPCResult
    RecvSetCpuSleepAllowed(const bool& aAllowed) override;

    mozilla::ipc::IPCResult
    RecvGetScreenBrightness(double* brightness) override;

    mozilla::ipc::IPCResult
    RecvSetScreenBrightness(const double& aBrightness) override;

    mozilla::ipc::IPCResult
    RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds) override;

    mozilla::ipc::IPCResult
    RecvSetTimezone(const nsCString& aTimezoneSpec) override;

    mozilla::ipc::IPCResult
    RecvGetTimezone(nsCString* aTimezoneSpec) override;

    mozilla::ipc::IPCResult
    RecvGetTimezoneOffset(int32_t* aTimezoneOffset) override;

    mozilla::ipc::IPCResult
    RecvEnableSystemClockChangeNotifications() override;

    mozilla::ipc::IPCResult
    RecvDisableSystemClockChangeNotifications() override;

    mozilla::ipc::IPCResult
    RecvEnableSystemTimezoneChangeNotifications() override;

    mozilla::ipc::IPCResult
    RecvDisableSystemTimezoneChangeNotifications() override;

    mozilla::ipc::IPCResult
    RecvModifyWakeLock(
            const nsString& aTopic,
            const WakeLockControl& aLockAdjust,
            const WakeLockControl& aHiddenAdjust,
            const uint64_t& aProcessID) override;

    mozilla::ipc::IPCResult
    RecvEnableWakeLockNotifications() override;

    mozilla::ipc::IPCResult
    RecvDisableWakeLockNotifications() override;

    mozilla::ipc::IPCResult
    RecvGetWakeLockInfo(
            const nsString& aTopic,
            WakeLockInformation* aWakeLockInfo) override;

    mozilla::ipc::IPCResult
    RecvEnableScreenConfigurationNotifications() override;

    mozilla::ipc::IPCResult
    RecvDisableScreenConfigurationNotifications() override;

    mozilla::ipc::IPCResult
    RecvLockScreenOrientation(
            const ScreenOrientationInternal& aOrientation,
            bool* allowed) override;

    mozilla::ipc::IPCResult
    RecvUnlockScreenOrientation() override;

    mozilla::ipc::IPCResult
    RecvEnableSwitchNotifications(const SwitchDevice& aDevice) override;

    mozilla::ipc::IPCResult
    RecvDisableSwitchNotifications(const SwitchDevice& aDevice) override;

    mozilla::ipc::IPCResult
    RecvGetCurrentSwitchState(
            const SwitchDevice& aDevice,
            SwitchState* aState) override;

    mozilla::ipc::IPCResult
    RecvFactoryReset(const nsString& aReason) override;

    mozilla::ipc::IPCResult
    RecvEnableSensorNotifications(const SensorType& aSensor) override;

    mozilla::ipc::IPCResult
    RecvDisableSensorNotifications(const SensorType& aSensor) override;

    void
    ActorDestroy(ActorDestroyReason aWhy) override;

    MOZ_IMPLICIT HalParent();
    virtual ~HalParent();
};
} // namespace hal_sandbox
} // namespace mozilla


// C++ file contents
namespace mozilla {
namespace hal_sandbox {
mozilla::ipc::IPCResult
HalParent::RecvVibrate(
        nsTArray<uint32_t>&& pattern,
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
}

mozilla::ipc::IPCResult
HalParent::RecvCancelVibrate(
        nsTArray<uint64_t>&& id,
        PBrowserParent* browser)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableNetworkNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableNetworkNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetCurrentNetworkInformation(NetworkInformation* aNetworkInfo)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetScreenEnabled(bool* enabled)
{
}

mozilla::ipc::IPCResult
HalParent::RecvSetScreenEnabled(const bool& aEnabled)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetKeyLightEnabled(bool* enabled)
{
}

mozilla::ipc::IPCResult
HalParent::RecvSetKeyLightEnabled(const bool& aEnabled)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetCpuSleepAllowed(bool* allowed)
{
}

mozilla::ipc::IPCResult
HalParent::RecvSetCpuSleepAllowed(const bool& aAllowed)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetScreenBrightness(double* brightness)
{
}

mozilla::ipc::IPCResult
HalParent::RecvSetScreenBrightness(const double& aBrightness)
{
}

mozilla::ipc::IPCResult
HalParent::RecvAdjustSystemClock(const int64_t& aDeltaMilliseconds)
{
}

mozilla::ipc::IPCResult
HalParent::RecvSetTimezone(const nsCString& aTimezoneSpec)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetTimezone(nsCString* aTimezoneSpec)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetTimezoneOffset(int32_t* aTimezoneOffset)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableSystemClockChangeNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableSystemClockChangeNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableSystemTimezoneChangeNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableSystemTimezoneChangeNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvModifyWakeLock(
        const nsString& aTopic,
        const WakeLockControl& aLockAdjust,
        const WakeLockControl& aHiddenAdjust,
        const uint64_t& aProcessID)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableWakeLockNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableWakeLockNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetWakeLockInfo(
        const nsString& aTopic,
        WakeLockInformation* aWakeLockInfo)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableScreenConfigurationNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableScreenConfigurationNotifications()
{
}

mozilla::ipc::IPCResult
HalParent::RecvLockScreenOrientation(
        const ScreenOrientationInternal& aOrientation,
        bool* allowed)
{
}

mozilla::ipc::IPCResult
HalParent::RecvUnlockScreenOrientation()
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableSwitchNotifications(const SwitchDevice& aDevice)
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableSwitchNotifications(const SwitchDevice& aDevice)
{
}

mozilla::ipc::IPCResult
HalParent::RecvGetCurrentSwitchState(
        const SwitchDevice& aDevice,
        SwitchState* aState)
{
}

mozilla::ipc::IPCResult
HalParent::RecvFactoryReset(const nsString& aReason)
{
}

mozilla::ipc::IPCResult
HalParent::RecvEnableSensorNotifications(const SensorType& aSensor)
{
}

mozilla::ipc::IPCResult
HalParent::RecvDisableSensorNotifications(const SensorType& aSensor)
{
}

void
HalParent::ActorDestroy(ActorDestroyReason aWhy)
{
}

MOZ_IMPLICIT HalParent::HalParent()
{
    MOZ_COUNT_CTOR(HalParent);
}

MOZ_IMPLICIT HalParent::~HalParent()
{
    MOZ_COUNT_DTOR(HalParent);
}

} // namespace hal_sandbox
} // namespace mozilla
#endif // if 0

#endif // ifndef PHalParent_h
